Bug 225226 - Bonding fails due to errors in network-functions.
Bonding fails due to errors in network-functions.
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Kernel Maintainer List
Brian Brock
Depends On:
  Show dependency treegraph
Reported: 2007-01-29 15:43 EST by J.H. Prins
Modified: 2008-05-06 15:07 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2008-05-06 15:07:24 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
Diff file for network-functions in /etc/sysconfig/network-scripts to solve the problem. (950 bytes, patch)
2007-01-29 15:43 EST, J.H. Prins
no flags Details | Diff

  None (edit)
Description J.H. Prins 2007-01-29 15:43:32 EST
Description of problem:

When you configure a type 4 network bond with 2 e1000 network interfaces and use
DHCP to supply the bond with an IP address the bond fails to come up due to
errors in the check_link_down function in network-functions. 
The check_link_down function is called from the ifup-eth script during
initialisation of the bond. This function in turn calls the mii-tool and the
ethtool to check the MII status of the configured bond. Both mii-tool and
ethtool fail to correctly return the status of the bond. mii-tool returns that
the bond is down while /proc/net/bonding/bond0 tells the bond is up. ethtool
completly fails to identify the bond and tells it can't return any data. 

Version-Release number of selected component (if applicable):


How reproducible:

Create a bond with 2 e1000 interfaces and configure it to use dhcp. The bond
will fail to come online. 

Steps to Reproduce:
1. Install FC5 with latest updates.
2. Configure bond with the following config files:



alias bond0 bonding
options bond0 mode=4 miimon=100 lacp_rate=fast

3. Configure a LACP dynamic link agregation pair on the connected switch.

4. Try to bring the network online.
Actual results:

Bond0 will be brought down and there will be no enslaved interfaces.

Expected results:

Bond0 should come online with an actual IP address and eth0 and eth1 should be
enslaved to bond0

Additional info:
Comment 1 J.H. Prins 2007-01-29 15:43:33 EST
Created attachment 146865 [details]
Diff file for network-functions in /etc/sysconfig/network-scripts to solve the problem.
Comment 2 Bill Nottingham 2007-01-29 15:47:40 EST
Rather than reporting MII status completely separately through another
interface, bonding devices should support the same interfaces.
Comment 3 J.H. Prins 2007-01-29 15:53:06 EST
True. But mii-tool is deprecated as far as I know and ethtool misidentifies
bonding interfaces completly. The only sollution at the moment is use the
interface for bonding interfaces that is available to check the MII status. This
is /proc/net/bonding/<bond>
Comment 4 Marc Maurer 2007-01-29 16:32:08 EST
commit fae0ef93df6f6b3ebf9209d4be7112f97405814c to might be what is needed:

commit fae0ef93df6f6b3ebf9209d4be7112f97405814c
Author: Andy Gospodarek <andy@greyhouse.net>
Date:   Tue Nov 21 11:46:44 2006 -0500

    [PATCH] bonding: incorrect bonding state reported via ioctl
    This is a small fix-up to finish out the work done by Jay Vosburgh to
    add carrier-state support for bonding devices.  The output in
    /proc/net/bonding/bondX was correct, but when collecting the same info
    via an iotcl it could still be incorrect.
    Signed-off-by: Andy Gospodarek <andy@greyhouse.net>
    Cc: Jeff Garzik <jeff@garzik.org>
    Cc: Stephen Hemminger <shemminger@osdl.org>
    Signed-off-by: Andrew Morton <akpm@osdl.org>
    Signed-off-by: Jeff Garzik <jeff@garzik.org>
    Signed-off-by: Chris Wright <chrisw@sous-sol.org>
Comment 5 J.H. Prins 2007-02-01 06:27:15 EST
It seems indeed that this patch is the one we need. We have build a RPM with a
2.6.19-2 kernel for FC5, which includes this patch and what we see is that
mii-tool properly identifies the link as being up. The speed etc are incorrect
but that doesn't matter.
Ethtool still doesn't give any proper information. 
[root@cl146 network-scripts]# mii-tool bond0
bond0: 10 Mbit, half duplex, link ok
[root@cl146 network-scripts]# ethtool bond0
Settings for bond0:
No data available
Comment 6 Bug Zapper 2008-04-04 01:47:24 EDT
Fedora apologizes that these issues have not been resolved yet. We're
sorry it's taken so long for your bug to be properly triaged and acted
on. We appreciate the time you took to report this issue and want to
make sure no important bugs slip through the cracks.

If you're currently running a version of Fedora Core between 1 and 6,
please note that Fedora no longer maintains these releases. We strongly
encourage you to upgrade to a current Fedora release. In order to
refocus our efforts as a project we are flagging all of the open bugs
for releases which are no longer maintained and closing them.

If this bug is still open against Fedora Core 1 through 6, thirty days
from now, it will be closed 'WONTFIX'. If you can reporduce this bug in
the latest Fedora version, please change to the respective version. If
you are unable to do this, please add a comment to this bug requesting
the change.

Thanks for your help, and we apologize again that we haven't handled
these issues to this point.

The process we are following is outlined here:

We will be following the process here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping to ensure this
doesn't happen again.

And if you'd like to join the bug triage team to help make things
better, check out http://fedoraproject.org/wiki/BugZappers
Comment 7 Bug Zapper 2008-05-06 15:07:23 EDT
This bug is open for a Fedora version that is no longer maintained and
will not be fixed by Fedora. Therefore we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen thus bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.